/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var babel = (function(babel) {
  if (babel.loadLib) { return babel; }

  /**
   * Translate to save the configuration
   */
  babel.ing = 
  {
    "true": "yes",
    "false": "no",

    // params translate
    size: "size",
    image_loader: "image_loader",
    expand: "expand",
    decimal_symbol: "decimal_symbol",
    antialias: "antialias",
    undo: "undo",
    name: "name",
    version: "Version",
    language: "Language",
    buttons: "Buttons",
    about: "about",
    config: "config",
    init: "init", 
    clear: "clear",
    rowsNorth: "rows_north", 
    rowsSouth: "rows_south", 
    widthEast: "width_east", 
    widthWest: "width_west", 
    heightRows: "height",

    // space translate
    type: "type",
    width: "width",
    height: "height",
    drawif: "draw-if",
    fixed: "fixed",
    scale: "scale",
    bg_display: "bg_display",
    topleft: "topleft",
    stretch: "stretch",
    patch: "patch",
    imgcenter: "center",
    background: "background",
    net: "net",
    net10: "net10",
    axes: "axes",
    numbers: "numbers",
    x_axis: "x-axis",
    y_axis: "y-axis",
    sensitive_to_mouse_movements: "sensitive_to_mouse_movements",
    render: "render",
    sort: "sort",
    painter: "painter",
    raytrace: "ray trace",
    split: "split",

    // control translate
    Buttons: "Buttons",
    numeric: "numeric",
    graphic: "graphic",
    gui: "gui",
    spinner: "spinner",
    textfield: "textfield",
    menu: "menu",
    scrollbar: "scrollbar",
    button: "button",
    region: "region",
    north: "north",
    south: "south",
    east: "east",
    west: "west",
    interior: "interior",
    external: "external",
    scenario: "scenario",
    space: "space",
    expression: "expresion",
    value: "value",
    discrete: "discrete",
    decimals: "decimals",
    visible: "visible",
    onlyText: "only_text",
    evaluate: "evaluate",
    answer: "answer",
    options: "options",
    min: "min",
    max: "max",
    color: "colour",
    colorInt: "int-colour",
    bold: "bold",
    italics: "italics",
    underlined: "underlined",
    font_size: "font size",
    activeif: "active-if",
    exponentialif: "exponential-if",
    constraint: "constraint",
    action: "action",
    calculate: "calculate",
    init: "init",
    clear: "clear",
    animate: "animate",
    openURL: "open URL",
    openScene: "open Scene",
    playAudio: "play",
    initAnimation: "Init Animation",

    // definitions translate
    constant: "constant",
    variable: "variable",
    "function": "function",
    algorithm: "algorithm",
    array: "array",
    matrix: "matrix",
    rows: "rows",
    columns: "columns",
    onlyOnce: "only-once",
    always: "always",
    range: "range",
    doExpr: "do",
    whileExpr: "while",
    file: "file",

    // programs translate
    "event": "event",
    execution: "execution",
    condition: "condition",
    alternate: "alternate",
    msg_pos: "msg_pos",
    center: "center",
    top_left: "top_left",
    top_center: "top_center",
    top_right: "top_right",
    left: "left",
    right: "right",
    bottom_left: "bottom_left",
    bottom: "bottom",
    bottom_right: "bottom_right",

    // graphcs translate
    equation: "equation",
    curve: "curve",
    sequence: "sequence",
    point: "point",
    segment: "segment",
    arrow: "arrow",
    polygon: "polygon",
    rectangle: "rectangle",
    arc: "arc",
    fill: "fill",
    text: "text",
    image: "image",
    macro: "macro",
    abs_coord: "abs_coord",
    trace: "trace",
    family: "family",
    editable: "editable",
    fillP: "fill+",
    fillM: "fill-",
    parameter: "parameter",
    font: "font",
    spear: "spear",
    radius: "radius",
    end: "end",
    vectors: "vectors",
    border: "color_text_border",
    opacity: "opacity",
    inirot: "inirot",
    inipos: "inipos",
    endrot: "endrot",
    endpos: "endpos",

    interval: "interval",
    steps: "steps",

    // graphcs3D translate
    backcolor: "backcolor",
    edges: "edges",
    model: "model",
    triangle: "triangle",
    face: "face",
    polireg: "regpoly",
    surface: "surface",
    cube: "cube",
    box: "box",
    cone: "cone",
    cylinder: "cylinder",
    sphere: "sphere",
    tetrahedron: "tetrahedron",
    octahedron: "octahedron",
    dodecahedron: "dodecahedron",
    icosahedron: "icosahedron",
    ellipsoid: "ellipsoid",
    torus: "torus",
    light: "light",
    metal: "metal",
    wire: "wire",
    length: "length",

    // animation translate
    Animation: "Animation",
    delay: "delay",
    controls: "controls",
    loop: "loop",
  }

  return babel;
})(babel || {});
